<?php

namespace HCM\FPA\Calculos\Geral;

use HCM\Util\DateUtil;
use HCM\Util\Repositories;
use HCM\FPA\Entity\FpatipoassoceveEntity;
use HCM\FPA\Entity\FpatipoincideEntity;

class ValeTransporte{

    public static function calcula(
        $salario, $mes_competencia, $item_de_calculo,
        $assoc_eventos, $eventom, $nrOrg
    ){

        $nrevento =  $assoc_eventos->retornaEvento(FpatipoassoceveEntity::ASSOC_VALE_TRANSP_RECEB, $nrOrg);
        $evento_vale_recebido = $eventom->retornaEvento($nrevento);
        $nrevento =  $assoc_eventos->retornaEvento(FpatipoassoceveEntity::ASSOC_VALE_TRANSPORTE, $nrOrg);
        $evento_vale_descontado = $eventom->retornaEvento($nrevento);
        $itens = $item_de_calculo->retornaItens($evento_vale_recebido);
        $base = $item_de_calculo->calculaIncidencias(
            FpatipoincideEntity::INC_VALE_TRANSP, $mes_competencia, $eventom
        );
        if ($base === 0.0) {
            $base = $salario;
        }

        foreach ($itens as $indice) {
            $referencia_recebida = $item_de_calculo->retornaReferencia($indice);
            $valor_recebido = $item_de_calculo->retornaValor($indice);
            if ($referencia_recebida > 0) {
                $valor_descontado = ($base / 30) * $referencia_recebida;
                $calculoEvento = '('.$base.'(Base) / 30) * '.$referencia_recebida.'(Referência)';
            } else {
                $valor_descontado = $base;
                $calculoEvento = $base.'(base)';
            }

            $valor_descontado = $valor_descontado /100 * 6;
            $calculoEvento .= ' / 100 * 6 = '.$valor_descontado;

            if ($valor_descontado > $valor_recebido) {
                $valor_descontado = $valor_recebido;
            }

            $dtocorrencia = $item_de_calculo->retornaDtocorrencia($indice);

            MemoriaCalculo::getInstance()->escreveEventos($item_de_calculo->getNrcalculofolha(),$evento_vale_descontado,$calculoEvento,$dtocorrencia,$valor_descontado,$referencia_recebida,null,$base,null,100);
            $item_de_calculo->geraEvento(
                $evento_vale_descontado, $dtocorrencia, $valor_descontado, $referencia_recebida, 1
            );

            unset($dtocorrencia);
        }
    }


}

