<?php
namespace HCM\Geral\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;

class AlteOcupacaoRepository {

    public function __construct(Connection $connection, EntityManager $entityManager) {
        $this->connection = $connection;
        $this->entityManager = $entityManager;
    }

    public function retornaUltimaAlteOcupacaoPorDataInicio($nrorg, $nrvinculom, $dtiniocupacao)
    {
        $query = <<<SQL
SELECT *
FROM GPE_ALTEOCUPACAO
WHERE NRORG = :P_NRORG
AND NRVINCULOM = :P_VINCULOM
AND DTINIOCUPACAO = ( SELECT MAX(DTINIOCUPACAO)
                     FROM GPE_ALTEOCUPACAO B
                    WHERE B.NRORG = :P_NRORG
                      AND B.NRVINCULOM = :P_VINCULOM
                      AND B.DTINIOCUPACAO <= :P_DTINIOCUPACAO )
SQL;
        $params = array(
            'P_NRORG'       => $nrorg,
            'P_VINCULOM'    => $nrvinculom,
            'P_DTINIOCUPACAO' => $dtiniocupacao,
        );
        return $this->connection->fetchAll($query, $params);
    }

    public function retornaProximaAlteOcupacao($nrorg, $nrvinculom, $dtiniocupacao) {
    
        if(is_string($dtiniocupacao)) $dtiniocupacao = substr($dtiniocupacao, 0, 10);
    
        $query = <<<SQL
SELECT *
  FROM GPE_ALTEOCUPACAO
 WHERE NRORG       =  :P_NRORG
   AND NRVINCULOM  = :P_VINCULOM
   AND DTINIOCUPACAO = (SELECT MIN(DTINIOCUPACAO)
                        FROM GPE_ALTEOCUPACAO B
                       WHERE B.NRORG       = GPE_ALTEOCUPACAO.NRORG
                         AND B.NRVINCULOM  = GPE_ALTEOCUPACAO.NRVINCULOM
                         AND B.DTINIOCUPACAO > TO_DATE(:P_DTINIOCUPACAO, 'DD/MM/YYYY'))
SQL;
     $params = array('P_NRORG'       => $nrorg,
                     'P_VINCULOM'    => $nrvinculom,
                     'P_DTINIOCUPACAO' => $dtiniocupacao);
                      
        return $this->connection->fetchAll($query, $params);
    }

} 
