<?php
namespace Service\Hcm;

class OcupacaoService {

    private $entityManager;

    public function __construct(\Doctrine\ORM\EntityManager $entityManager)
    {
        $this->entityManager = $entityManager;
    }

    public function getCargos($dtmescompetencia, $nrorg) {
        try {
            $query = <<<SQL
SELECT
    OH.*,
    OM.*
FROM
    GPE_OCUPACAOM OM
    LEFT JOIN GPE_OCUPACAOH OH ON OM.NROCUPACAOM = OH.NROCUPACAOM
                                  AND OH.NRORG = OM.NRORG
                                  AND OH.DTMESCOMPETENC = (
        SELECT
            MAX(OHH.DTMESCOMPETENC)
        FROM
            GPE_OCUPACAOH OHH
        WHERE
                OHH.NRORG = :P_NRORG
            AND OHH.NROCUPACAOM = OH.NROCUPACAOM
            AND OHH.DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY')
    )
WHERE
    ( OM.NRORG = :P_NRORG )
    AND ( DTFIMVIGENCIA >= :P_DTMESCOMPETENC
          OR DTFIMVIGENCIA IS NULL )
SQL;
            $params = array(
                'P_DTMESCOMPETENC' => $dtmescompetencia,
                'P_NRORG' => $nrorg,
            );
            return $this->entityManager->getConnection()->fetchAll($query, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function getAlteracoesOcupacao($dtinicio, $dtfim, $nrvinculom, $dtmescompetenc, $nrorg){
        try {
            $query = <<<SQL
SELECT
    VM.*,
    VH.*,
    AO.*,
    OH.CDINTEGRACAO AS CDINTEGCARGO
FROM
         GPE_VINCULOM VM
    JOIN GPE_VINCULOH     VH ON VH.NRVINCULOM = VM.NRVINCULOM
                            AND VH.NRORG = VM.NRORG
                            AND VH.DTMESCOMPETENC = (
        SELECT
            MAX(H1.DTMESCOMPETENC) DTMESCOMPETENC
        FROM
            GPE_VINCULOH H1
        WHERE
                H1.NRVINCULOM = VH.NRVINCULOM
            AND H1.NRORG = VH.NRORG
            AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC
    )
    LEFT JOIN GPE_ALTEOCUPACAO AO ON AO.NRORG = VM.NRORG
                                     AND AO.NRVINCULOM = VM.NRVINCULOM
    LEFT JOIN GPE_OCUPACAOH OH ON OH.NRORG = VM.NRORG AND
                                     OH.NROCUPACAOM = AO.NROCUPACAOM AND
                                     OH.DTMESCOMPETENC = (
                                        SELECT
                                            MAX(OHH.DTMESCOMPETENC)
                                        FROM
                                            GPE_OCUPACAOH OHH
                                        WHERE
                                            OHH.NRORG = OH.NRORG AND
                                            OHH.NROCUPACAOM = OH.NROCUPACAOM AND
                                            OHH.DTMESCOMPETENC <=:P_DTMESCOMPETENC
                                     )
WHERE
        VM.NRORG = :P_NRORG
    AND ( :P_NRVINCULOM IS NULL
          OR INSTR(','
                   || :P_NRVINCULOM
                   || ',', ','
                           || AO.NRVINCULOM
                           || ',') > 0 )
    AND (
            ((:P_DTINICIO IS NULL OR AO.DTINIOCUPACAO >= :P_DTINICIO) AND (:P_DTFIM IS NULL OR AO.DTINIOCUPACAO <= :P_DTFIM)) 
            OR ((:P_DTINICIO IS NULL OR AO.DTFIMOCUPACAO >= :P_DTINICIO) AND (:P_DTFIM IS NULL OR AO.DTFIMOCUPACAO <= :P_DTFIM))
        )
    AND ( VM.DTRESCISAOVINC IS NULL
          OR VM.DTRESCISAOVINC > LAST_DAY(:P_DTMESCOMPETENC) )
SQL;
        $params = array(
            'P_NRVINCULOM' => $nrvinculom,
            'P_DTINICIO' => $dtinicio,
            'P_DTFIM' => $dtfim,
            'P_NRORG' => $nrorg,
            'P_DTMESCOMPETENC' => $dtmescompetenc,
        );

            return $this->entityManager->getConnection()->fetchAll($query, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

}