/* Sistemas Integrados TECNISA

Nome: 7000_CLISTP_RETIRADA_AUTOMATICA_SKYCHEFS

Descrio:
Gerao das retiradas correspondentes a uma requisio.
Gravao das tabelas RETIRADA, LANCTOESOQ, ITLANCTOEST, ITEMRETI.

P_NRSEQUENCIAL - Nmero da requisio
P_NMARQUIVO    - Nome do arquivo

-- @C:\7000_clistp_retirada_automatica_skychefs.sql
-- EXECUTE RETIRADA_AUTOMATICA_SKYCHEFS('0000102853','REQATD0202041210000000102853.TXT');
-- SET SERVEROUTPUT ON
-- DBMS_OUTPUT.PUT_LINE('xx');

Criao:
22/05/2001 - Bruno Leonardo de Oliveira


         DBMS_OUTPUT.PUT_LINE(V_NRREQUISI);
         DBMS_OUTPUT.PUT_LINE(V_NRITEREQU);
         DBMS_OUTPUT.PUT_LINE(V_CDSERVICO);
         DBMS_OUTPUT.PUT_LINE(V_CDUSUARIO);
         DBMS_OUTPUT.PUT_LINE(V_CDPRODUTO);
         DBMS_OUTPUT.PUT_LINE(V_QTREQUISI);
         DBMS_OUTPUT.PUT_LINE(V_UNMEDIREQ);
         DBMS_OUTPUT.PUT_LINE(V_QTDEATEND);



*/

CREATE TABLE USR_RETIRADA_AUTOMATICA
  (NRSEQUENCIAL VARCHAR2(10),
   NRLINHA      VARCHAR(3),
   DSLINHA      VARCHAR2(250),
   PRIMARY KEY (NRSEQUENCIAL, NRLINHA))
/

CREATE OR REPLACE PROCEDURE RETIRADA_AUTOMATICA_SKYCHEFS
  (P_NRSEQUENCIAL IN VARCHAR2,
   P_DTARQUIVO    IN DATE,
   P_FILIPROC     IN VARCHAR2) IS

   V_NRREQUISI   VARCHAR2(10);
   V_NRITEREQU   VARCHAR2(3);
   V_CDSERVICO   VARCHAR2(5);
   V_CDUSUARIO   VARCHAR2(12);
   V_CDPRODUTO   VARCHAR2(10);
   V_QTREQUISI   VARCHAR2(15);
   V_UNMEDIREQ   VARCHAR2(10);
   V_QTDEATEND   VARCHAR2(15);

   V_NRLANCESTQ  VARCHAR2(20);

   V_CDFILIAL    VARCHAR2(4);
   V_NRRETIRADA  VARCHAR2(20);
   V_NRCARDAPIO  VARCHAR2(20);
   V_DTCARDAPIO  DATE;

   V_SEQUITEM    NUMBER;

   V_VERIFDTPO   DATE;
   V_IDCTRLESTQ  VARCHAR2(1);
   V_IDCNTRESTOQ VARCHAR2(1);
   V_IDESTONLINE VARCHAR2(1);

   V_IDUTILALMOX  VARCHAR2(1);
   V_IDUTILLCESTQ VARCHAR2(1);
   V_IDUTILLOTE   VARCHAR2(1);
   V_CDALMOXARIFE VARCHAR2(6);
   V_CDLOCALESTOQ VARCHAR2(6);
   V_CDPRODMOVI   VARCHAR2(10);

   V_QTEXTRA      NUMBER;
   V_QTDEVOL      NUMBER;

   V_QTACLOTE     NUMBER;
   V_QTACPREV     NUMBER;
   V_QTLOTE       NUMBER;
   V_VRFATOCONV   NUMBER;

BEGIN

   V_SEQUITEM := 1;

   FOR CUR_ARQUIVO IN
      (SELECT
          DSLINHA
       FROM
          USR_RETIRADA_AUTOMATICA
       WHERE
          NRSEQUENCIAL = P_NRSEQUENCIAL
       ORDER BY
          NRLINHA)
   LOOP

      V_NRREQUISI := SUBSTR(CUR_ARQUIVO.DSLINHA, 001, 10);
      V_NRITEREQU := SUBSTR(CUR_ARQUIVO.DSLINHA, 011, 03);
      V_CDSERVICO := SUBSTR(CUR_ARQUIVO.DSLINHA, 017, 05);
      V_CDUSUARIO := '00000000'||SUBSTR(CUR_ARQUIVO.DSLINHA, 062, 04);
      V_QTREQUISI := SUBSTR(CUR_ARQUIVO.DSLINHA, 188, 15);
      V_UNMEDIREQ := SUBSTR(CUR_ARQUIVO.DSLINHA, 183, 05);
      V_QTDEATEND := V_QTREQUISI;

      SELECT CDPRODUTO INTO V_CDPRODUTO
      FROM PRODUTO
      WHERE CDARVPROD = SUBSTR(CUR_ARQUIVO.DSLINHA, 106, 12);  /* CDARVPROD */


      /* - OPERAES REALIZADAS S UMA VEZ PARA TODOS OS ITENS -------------- */
      IF V_SEQUITEM = 1 THEN

         V_CDFILIAL := P_FILIPROC;

         SELECT
            NVL(MAX(IDUTILALMOX),'N'),
            NVL(MAX(IDUTILLCESTQ),'N'),
            NVL(MAX(IDUTILLOTE),'N')
         INTO
            V_IDUTILALMOX,
            V_IDUTILLCESTQ,
            V_IDUTILLOTE
         FROM
            PARAMFILIAL
         WHERE
            CDFILIAL = V_CDFILIAL;

/*       SELECT
            MIN(DTPREVRETI)
         INTO
            V_DTCARDAPIO
         FROM
            PREVRETI
         WHERE
            CDFILIAL   = V_CDFILIAL   AND
            CDSERVFILI = V_CDSERVICO  AND
            NRREQUEXTR = V_NRREQUISI;*/
         V_DTCARDAPIO := P_DTARQUIVO;   

         SELECT
            MIN(NRCARDAPIO)
         INTO
            V_NRCARDAPIO
         FROM
            CARDADIA
         WHERE
            CDFILIAL   = V_CDFILIAL   AND
            CDSERVFILI = V_CDSERVICO  AND
            DTCARDAPIO = V_DTCARDAPIO;

         NOVO_CODIGO('LANCTOEST'||V_CDFILIAL, V_NRLANCESTQ,1);
         V_NRLANCESTQ := SUBSTR(V_NRLANCESTQ,11,10);
         NOVO_CODIGO('RETIRADA'||V_CDFILIAL , V_NRRETIRADA,1);
         V_NRRETIRADA := SUBSTR(V_NRRETIRADA,11,10);

         IF V_NRCARDAPIO IS NULL THEN
            NOVO_CODIGO('CARDAPIO'||V_CDFILIAL, V_NRCARDAPIO,1);
            V_NRCARDAPIO := SUBSTR(V_NRCARDAPIO,11,10);

            INSERT INTO CARDADIA
              (CDFILIAL,
               NRCARDAPIO,
               CDSERVFILI,
               CDOPERADOR,
               DTCARDAPIO,
               DTMESCARD,
               DTULTATUACAR,
               IDEFETINFO)
            VALUES
              (V_CDFILIAL,
               V_NRCARDAPIO,
               V_CDSERVICO,
               V_CDUSUARIO,
               V_DTCARDAPIO,
               ADD_MONTHS(LAST_DAY(V_DTCARDAPIO)+1,-1),
               SYSDATE,
               'N');

         END IF;

         INSERT INTO LANCTOESTOQ
           (CDFILIAL,
            NRLANCESTQ,
            IDTPLANCTO,
            DTLANCESTQ,
            DSLANCESTQ,
            CDFILIMOVI,
            CDOPERADOR)
         VALUES
           (V_CDFILIAL,
            V_NRLANCESTQ,
            '3',
            V_DTCARDAPIO,
            'Retirada para o cardpio do dia '||V_DTCARDAPIO||' ,Servio '||V_CDSERVICO,
            V_CDFILIAL,
            V_CDUSUARIO);

         INSERT INTO RETIRADA
           (CDFILIAL,
            NRRETIRADA,
            NRCARDAPIO,
            DTRETIRADA,
            NRREQUEXTRRE,
            CDFILANCESTQ,
            NRLANCESTQ,
            IDRETIPRAT)
         VALUES
           (V_CDFILIAL,
            V_NRRETIRADA,
            V_NRCARDAPIO,
            V_DTCARDAPIO,
            V_NRREQUISI,
            V_CDFILIAL,
            V_NRLANCESTQ,
            'N');
      END IF;

      IF V_IDUTILALMOX = 'N' THEN
         V_CDALMOXARIFE := ' ';
      ELSE
         SELECT
            NVL(MAX(NVL(P.CDALMOXARIFE, PR.CDALMOXARIFE)), ' ')
         INTO
            V_CDALMOXARIFE
         FROM
            PRODFILI P,
            PARAMFILIAL PR
         WHERE
            PR.CDFILIAL = V_CDFILIAL AND
            PR.CDFILIAL = P.CDFILIAL AND
            P.CDPRODUTO = V_CDPRODUTO;
      END IF;

      SELECT
         MAX(CDPRODESTO),
         MAX(VRFATOCONV)
      INTO
         V_CDPRODMOVI,
         V_VRFATOCONV
      FROM
         PRODUTO
      WHERE
         CDPRODUTO = V_CDPRODUTO;

      IF V_IDUTILLCESTQ = 'N' THEN
         V_CDLOCALESTOQ := ' ';
      ELSE
         SELECT
            NVL(MAX(NVL(P.CDALMOXARIFE, PR.CDALMOXARIFE)), ' ')
         INTO
            V_CDLOCALESTOQ
         FROM
            PRODFILI P,
            PARAMFILIAL PR
         WHERE
            PR.CDFILIAL = V_CDFILIAL AND
            PR.CDFILIAL = P.CDFILIAL AND
            P.CDPRODUTO = V_CDPRODUTO;
      END IF;

      IF V_IDUTILLOTE = 'S' THEN
         V_QTACLOTE := TO_NUMBER(V_QTDEATEND)/100000;
         V_QTACPREV := TO_NUMBER(V_QTREQUISI)/100000;

         FOR C_POSESTATU IN (SELECT NRLOTEESTQ, NRSUBLOTE, QTTOTALESTOQ, VRTOTALESTOQ
                             FROM POSESTATU
                             WHERE CDFILIAL     = V_CDFILIAL     AND
                                   CDALMOXARIFE = V_CDALMOXARIFE AND
                                   CDLOCALESTOQ = V_CDLOCALESTOQ AND
                                   CDPRODUTO    = V_CDPRODMOVI   AND
                                   QTTOTALESTOQ > 0
                             ORDER BY NRLOTEESTQ, NRSUBLOTE) LOOP

            IF V_QTACLOTE > 0 THEN
               IF V_QTACLOTE > C_POSESTATU.QTTOTALESTOQ THEN
                  V_QTLOTE   := C_POSESTATU.QTTOTALESTOQ;
                  V_QTACLOTE := V_QTACLOTE - V_QTLOTE;
               ELSE
                  V_QTLOTE   := V_QTACLOTE;
                  V_QTACLOTE := 0;
               END IF;

               INSERT INTO ITLANCTOEST
                 (CDFILIAL,
                  NRLANCESTQ,
                  NRSEQUITEM,
                  CDPRODUTO,
                  QTLANCTOEST,
                  IDTIPOMOVI,
                  DTLANCMOVI,
                  IDORDEMCLC,
                  QTTOTLANCTO,
                  CDFILIMOVI,
                  CDPRODMOVI,
                  IDEVOLESTOQ,
                  CDALMOXARIFE,
                  CDLOCALESTOQ,
                  NRLOTEESTQ,
                  NRSUBLOTE,
                  CDTIPORETI)
               VALUES
                 (V_CDFILIAL,
                  V_NRLANCESTQ,
                  LPAD(V_SEQUITEM, 4, '0'),
                  V_CDPRODUTO,
                  V_QTLOTE,
                  '3',
                  V_DTCARDAPIO,
                  '9',
                  V_QTLOTE,
                  V_CDFILIAL,
                  V_CDPRODMOVI,
                  'S',
                  V_CDALMOXARIFE,
                  V_CDLOCALESTOQ,
                  C_POSESTATU.NRLOTEESTQ,
                  C_POSESTATU.NRSUBLOTE,
                  '01');

               /*TESTE DAS QUANTIDADES EXTRAS E DEVOLVIDAS*/

               V_QTEXTRA := 0;
               V_QTDEVOL := 0;

               IF (V_QTLOTE) > (TO_NUMBER(V_QTREQUISI)/100000) THEN
                  V_QTEXTRA := (V_QTLOTE) - (TO_NUMBER(V_QTREQUISI)/100000);
               ELSE
                  IF (V_QTLOTE) < (TO_NUMBER(V_QTREQUISI)/100000) THEN
                     V_QTDEVOL := ABS((V_QTLOTE) - (TO_NUMBER(V_QTREQUISI)/100000));
                  END IF;
               END IF;

               INSERT INTO ITEMRETI
                 (CDFILIAL,
                  NRRETIRADA,
                  NRCARDAPIO,
                  QTPREVISRETI,
                  QTEXTRARETI,
                  QTDEVOLVRETI,
                  QTRETIRADA,
                  NRSEQUITRETI,
                  NRLANCESTQ,
                  NRSEQUITEM,
                  CDPRODUTO,
                  CDFIITLANEST,
                  CDTIPORETI)
               VALUES
                 (V_CDFILIAL,
                  V_NRRETIRADA,
                  V_NRCARDAPIO,
                  TO_NUMBER(V_QTREQUISI)/100000,
                  V_QTEXTRA,
                  V_QTDEVOL,
                  V_QTLOTE,
                  LPAD(V_SEQUITEM, 4, '0'),
                  V_NRLANCESTQ,
                  LPAD(V_SEQUITEM, 4, '0'),
                  V_CDPRODUTO,
                  V_CDFILIAL,
                  '01');

                  V_SEQUITEM := V_SEQUITEM + 1;
            END IF;
         END LOOP;
      ELSE
         INSERT INTO ITLANCTOEST
           (CDFILIAL,
            NRLANCESTQ,
            NRSEQUITEM,
            CDPRODUTO,
            QTLANCTOEST,
            IDTIPOMOVI,
            DTLANCMOVI,
            IDORDEMCLC,
            QTTOTLANCTO,
            CDFILIMOVI,
            CDPRODMOVI,
            IDEVOLESTOQ,
            CDALMOXARIFE,
            CDLOCALESTOQ,
            NRLOTEESTQ,
            NRSUBLOTE,
            CDTIPORETI)
         VALUES
           (V_CDFILIAL,
            V_NRLANCESTQ,
            LPAD(V_SEQUITEM, 4, '0'),
            V_CDPRODUTO,
            TO_NUMBER(V_QTDEATEND)/100000,
            '3',
            V_DTCARDAPIO,
            '9',
            TO_NUMBER(V_QTDEATEND)/100000,
            V_CDFILIAL,
            V_CDPRODMOVI,
            'S',
            V_CDALMOXARIFE,
            V_CDLOCALESTOQ,
            ' ',
            ' ',
            '01');

         /*TESTE DAS QUANTIDADES EXTRAS E DEVOLVIDAS*/

         V_QTEXTRA := 0;
         V_QTDEVOL := 0;

         IF (TO_NUMBER(V_QTDEATEND)/100000) > (TO_NUMBER(V_QTREQUISI)/100000) THEN
            V_QTEXTRA := (TO_NUMBER(V_QTDEATEND)/100000) - (TO_NUMBER(V_QTREQUISI)/100000);
         ELSE
            IF (TO_NUMBER(V_QTDEATEND)/100000) < (TO_NUMBER(V_QTREQUISI)/100000) THEN
               V_QTDEVOL := ABS((TO_NUMBER(V_QTDEATEND)/100000) - (TO_NUMBER(V_QTREQUISI)/100000));
            END IF;
         END IF;

         INSERT INTO ITEMRETI
           (CDFILIAL,
            NRRETIRADA,
            NRCARDAPIO,
            QTPREVISRETI,
            QTEXTRARETI,
            QTDEVOLVRETI,
            QTRETIRADA,
            NRSEQUITRETI,
            NRLANCESTQ,
            NRSEQUITEM,
            CDPRODUTO,
            CDFIITLANEST,
            CDTIPORETI)
         VALUES
           (V_CDFILIAL,
            V_NRRETIRADA,
            V_NRCARDAPIO,
            TO_NUMBER(V_QTREQUISI)/100000,
            V_QTEXTRA,
            V_QTDEVOL,
            TO_NUMBER(V_QTDEATEND)/100000,
            LPAD(V_SEQUITEM, 4, '0'),
            V_NRLANCESTQ,
            LPAD(V_SEQUITEM, 4, '0'),
            V_CDPRODUTO,
            V_CDFILIAL,
            '01');
      END IF;

      /* - ROTINAS DE ATUALIZAO DE ESTOQUE -------------------------------- */

      SELECT
         MAX(IDCTRLESTQ)
      INTO
         V_IDCTRLESTQ
      FROM
         PARAMFILIAL
      WHERE
         (CDFILIAL = V_CDFILIAL);

      SELECT
         MAX(IDCNTRESTOQ)
      INTO
         V_IDCNTRESTOQ
      FROM
         PRODFILI
      WHERE
         (CDFILIAL  = V_CDFILIAL) AND
         (CDPRODUTO = V_CDPRODUTO);

      SELECT
         MAX(IDESTONLINE)
      INTO
         V_IDESTONLINE
      FROM
         PARAMFILIAL
      WHERE
         (CDFILIAL = V_CDFILIAL);

      IF (V_IDCTRLESTQ  <> 'N' OR (V_IDCTRLESTQ  IS NULL)) AND
         (V_IDCNTRESTOQ <> 'N' OR (V_IDCNTRESTOQ IS NULL)) AND
         (V_IDESTONLINE <> 'N' OR (V_IDESTONLINE IS NULL)) THEN

         ATUALIZA_ESTOQUE(V_CDFILIAL,
                          V_DTCARDAPIO,
                          TRUNC(SYSDATE),
                          V_CDFILIAL,
                          V_NRLANCESTQ);

         SELECT
            MIN(DTPOSIESTQ)
         INTO
            V_VERIFDTPO
         FROM
            POSESTDIA P
         WHERE
            (P.CDFILIAL    = V_CDFILIAL)   AND
            (P.CDPRODUTO   = V_CDPRODUTO)  AND
            (P.DTPOSIESTQ >= V_DTCARDAPIO) AND
            (P.QTESTOQDIA < 0 OR P.VRESTOQDIA < 0);

         IF NOT V_VERIFDTPO IS NULL THEN

            UPDATE ITLANCTOEST
            SET IDEVOLESTOQ = 'N'
            WHERE
               (CDFILIAL   = V_CDFILIAL)               AND
               (NRLANCESTQ = V_NRLANCESTQ)             AND
               (NRSEQUITEM = LPAD(V_SEQUITEM, 4, '0')) AND
               (CDPRODUTO  = V_CDPRODUTO)              AND
               (DTLANCMOVI = TRUNC(V_DTCARDAPIO))      AND
               (IDORDEMCLC = '9')                      AND
               (CDFILIMOVI = V_CDFILIAL)               AND
               (CDPRODMOVI = V_CDPRODUTO);

            ATUALIZA_ESTOQUE(V_CDFILIAL,
                             V_DTCARDAPIO,
                             TRUNC(SYSDATE),
                             V_CDFILIAL,
                             V_NRLANCESTQ);
         END IF;
      END IF;
      V_SEQUITEM := V_SEQUITEM + 1;
   END LOOP; /* LOOP DOS ITENS */
END;
/


-- VERSAO --
BEGIN ATUVEROBJ('RETIRADA_AUTOMATICA_SKYCHEFS','4.11.010'); END;
/

