/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_EFIL                                                     */
/* Tabela : ENDEFILI                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 03/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_EFIL'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_EFIL
GO

CREATE TRIGGER DTULTATU_EFIL
ON ENDEFILI
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'ENDEFILI', CDFILIAL, 'CDFILIAL=' + CDFILIAL + ';' +
                                       'IDTPENDEFILI='+ IDTPENDEFILI + ';', CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED)
   END
   ELSE BEGIN
      UPDATE ENDEFILI
      SET DTULTATUEFIL = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(ENDEFILI.SGESTADO,0)     = ISNULL(INSERTED.SGESTADO,0))     AND
            (ISNULL(ENDEFILI.DSENDEFILI,0)   = ISNULL(INSERTED.DSENDEFILI,0))   AND
            (ISNULL(ENDEFILI.NMBAIRFILI,0)   = ISNULL(INSERTED.NMBAIRFILI,0))   AND
            (ISNULL(ENDEFILI.NRCEPFILI,0)    = ISNULL(INSERTED.NRCEPFILI,0))    AND
            (ISNULL(ENDEFILI.NRTELEFILI,0)   = ISNULL(INSERTED.NRTELEFILI,0))   AND
            (ISNULL(ENDEFILI.NRFAXFILI,0)    = ISNULL(INSERTED.NRFAXFILI,0))    AND
            (ISNULL(ENDEFILI.CDPAIS,0)       = ISNULL(INSERTED.CDPAIS,0))       AND
            (ISNULL(ENDEFILI.CDMUNICIPIO,0)  = ISNULL(INSERTED.CDMUNICIPIO,0))  AND
            (ISNULL(ENDEFILI.IDTPENDEFILI,0) = ISNULL(INSERTED.IDTPENDEFILI,0)) AND
            (ISNULL(ENDEFILI.CDSENHEMAILF,0) = ISNULL(INSERTED.CDSENHEMAILF,0)) AND
            (ISNULL(ENDEFILI.DSSMTPEMAILF,0) = ISNULL(INSERTED.DSSMTPEMAILF,0)) AND
            (ISNULL(ENDEFILI.DSEMAILFILI,0)  = ISNULL(INSERTED.DSEMAILFILI,0));
   END;
END;
GO

UPDATE ENDEFILI SET DTULTATUEFIL = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATUEFIL IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUEFIL' and
            type = 'D')
   ALTER TABLE ENDEFILI DROP CONSTRAINT DEFAULT_DTULTATUEFIL
GO

ALTER TABLE ENDEFILI ADD CONSTRAINT DEFAULT_DTULTATUEFIL
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATUEFIL
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_EFIL','4.11.210';
GO

