-- ============================================================
--   Database name:  FOLHA                                   
--   DBMS name:      ORACLE Version 21.x 
--   Created on:     26/07/2024  17:00                        
--   Issue:          Fluxo Offline para o Portal do Gestor - PORTAL DO GESTOR

-- ============================================================
-- Table: GPE_MARCACAOOFFLINE
-- ============================================================


CREATE TABLE GPE_MARCACAOOFFLINE (
  NRORG                     NUMBER(10) NOT NULL,
  NRMARCACAOOFFLINE         VARCHAR2(36) NOT NULL,
  NRCHAVEVINCULO            VARCHAR2(20) NOT NULL,
  NMVINCULOM                VARCHAR2(100),
  DTHRMARCACAOPONTO         DATE NOT NULL,
  DTHRSINCRONIZACAO         DATE,
  IDSINCRONIZADO            VARCHAR2(1) DEFAULT 'N' NOT NULL,
  DSERROMARCACAO            VARCHAR2(4000),
  DTINCLUSAO                DATE DEFAULT SYSDATE NOT NULL,
  DTULTATU                  DATE,
  NRORGINCLUSAO             NUMBER NOT NULL,
  CDOPERINCLUSAO            VARCHAR2(12),
  NRORGULTATU               NUMBER,
  CDOPERULTATU              VARCHAR2(12),
  IDATIVO                   VARCHAR2(1) DEFAULT 'S' NOT NULL,
  CONSTRAINT PK_GPE_MARCACAOOFFLINE PRIMARY KEY (NRORG, NRMARCACAOOFFLINE)
);

CREATE INDEX IDX_GPE_MARCACAOOFFLINE_01 ON GPE_MARCACAOOFFLINE (NRORG, NRCHAVEVINCULO, DTHRMARCACAOPONTO);
CREATE INDEX IDX_GPE_MARCACAOOFFLINE_02 ON GPE_MARCACAOOFFLINE (NRORG, DTHRMARCACAOPONTO);

COMMIT;